All Endpoints

Request Headers

authorizationstring*required

Authorization token (required).

Request Body

retry_tokenstringoptional

The retry token provided by a previous incomplete or failed function execution.

from_cachebooleanoptional

If true, vector completion tasks use cached votes from the global ObjectiveAI votes cache when available. Has lower priority than `retry_token`, higher priority than `from_rng`.

from_rngbooleanoptional

If true, any remaining votes from vector completion tasks are generated via RNG. Has lower priority than `retry_token` or `from_cache`.

strategyunionoptional

Strategy for function execution. Defaults to 'default'. Use 'swiss_system' for vector functions to run tournament-style ranking across multiple rounds.

Variants
object

Default strategy for function execution.

Properties
type"default"*required
object

Swiss system strategy for vector function execution.

Properties
type"swiss_system"*required
poolnumbermin: 0max: 9007199254740991optional

How many vector responses for each execution. Default is 10.

roundsnumbermin: 0max: 9007199254740991optional

How many sequential rounds of comparison. Default is 3.

reasoningobjectoptional

If provided, a reasoning summary for the Function Execution will be generated. This reasoning summary attempts to detail why the final Output is what it is, based on AI assertions made during execution.

Properties
modelunion*required

The Ensemble LLM to use for this completion. May be a unique ID or an inline definition.

Variants
EnsembleLlmIdstring

The unique identifier for the Ensemble LLM.

EnsembleLlmBaseobject

An LLM to be used within an Ensemble or standalone with Chat Completions.

Properties
modelstring*required

The full ID of the LLM to use.

output_modeenum*required

For Vector Completions only, specifies the LLM's voting output mode. For "instruction", the assistant is instructed to output a key. For "json_schema", the assistant is constrained to output a valid key using a JSON schema. For "tool_call", the assistant is instructed to output a tool call to select the key.

Variants
"instruction"
"json_schema"
"tool_call"
synthetic_reasoningbooleanoptional

For Vector Completions only, whether to use synthetic reasoning prior to voting. Works for any LLM, even those that do not have native reasoning capabilities.

top_logprobsnumbermin: 0max: 20optional

For Vector Completions only, whether to use logprobs to make the vote probabilistic. This means that the LLM can vote for multiple keys based on their logprobabilities. Allows LLMs to express native uncertainty when voting.

prefix_messagesarrayoptional

A list of messages exchanged in a chat conversation. These will be prepended to every prompt sent to this LLM. Useful for setting context or influencing behavior.

Items
DeveloperMessageobject

Developer-provided instructions that the model should follow, regardless of messages sent by the user.

Properties
role"developer"*required
contentunion*required

Simple content.

Variants
SimpleContentTextstring

Plain text content.

SimpleContentPartsarray

An array of simple content parts.

Items
SimpleContentPartobject

A simple content part.

Properties
type"text"*required
textstring*required

The text content.

namestringoptional

An optional name for the participant. Provides the model information to differentiate between participants of the same role.

SystemMessageobject

Developer-provided instructions that the model should follow, regardless of messages sent by the user.

Properties
role"system"*required
contentunion*required

Simple content.

Variants
SimpleContentTextstring

Plain text content.

SimpleContentPartsarray

An array of simple content parts.

Items
SimpleContentPartobject

A simple content part.

Properties
type"text"*required
textstring*required

The text content.

namestringoptional

An optional name for the participant. Provides the model information to differentiate between participants of the same role.

UserMessageobject

Messages sent by an end user, containing prompts or additional context information.

Properties
role"user"*required
contentunion*required

Rich content.

Variants
RichContentTextstring

Plain text content.

RichContentPartsarray

An array of rich content parts.

Items
TextRichContentPartobject

A text rich content part.

Properties
type"text"*required
textstring*required

The text content.

ImageRichContentPartobject

An image rich content part.

Properties
type"image_url"*required
image_urlobject*required

The URL of the image and its optional detail level.

Properties
urlstring*required

Either a URL of the image or the base64 encoded image data.

detailenumoptional

Specifies the detail level of the image.

Variants
"auto"
"low"
"high"
AudioRichContentPartobject

An audio rich content part.

Properties
type"input_audio"*required
input_audioobject*required

The audio data and its format.

Properties
datastring*required

Base64 encoded audio data.

formatenum*required

The format of the encoded audio data.

Variants
"wav"
"mp3"
VideoRichContentPartobject

A video rich content part.

Properties
typeenum*required
Variants
"video_url"
"input_video"
video_urlobject*required
Properties
urlstring*required

URL of the video.

FileRichContentPartobject

A file rich content part.

Properties
type"file"*required
fileobject*required

The file to be used as input, either as base64 data, an uploaded file ID, or a URL.

Properties
file_datastringoptional

The base64 encoded file data, used when passing the file to the model as a string.

file_idstringoptional

The ID of an uploaded file to use as input.

filenamestringoptional

The name of the file, used when passing the file to the model as a string.

file_urlstringoptional

The URL of the file, used when passing the file to the model as a URL.

namestringoptional

An optional name for the participant. Provides the model information to differentiate between participants of the same role.

ToolMessageobject

Messages sent by tools in response to tool calls made by the assistant.

Properties
role"tool"*required
contentunion*required

Rich content.

Variants
RichContentTextstring

Plain text content.

RichContentPartsarray

An array of rich content parts.

Items
TextRichContentPartobject

A text rich content part.

Properties
type"text"*required
textstring*required

The text content.

ImageRichContentPartobject

An image rich content part.

Properties
type"image_url"*required
image_urlobject*required

The URL of the image and its optional detail level.

Properties
urlstring*required

Either a URL of the image or the base64 encoded image data.

detailenumoptional

Specifies the detail level of the image.

Variants
"auto"
"low"
"high"
AudioRichContentPartobject

An audio rich content part.

Properties
type"input_audio"*required
input_audioobject*required

The audio data and its format.

Properties
datastring*required

Base64 encoded audio data.

formatenum*required

The format of the encoded audio data.

Variants
"wav"
"mp3"
VideoRichContentPartobject

A video rich content part.

Properties
typeenum*required
Variants
"video_url"
"input_video"
video_urlobject*required
Properties
urlstring*required

URL of the video.

FileRichContentPartobject

A file rich content part.

Properties
type"file"*required
fileobject*required

The file to be used as input, either as base64 data, an uploaded file ID, or a URL.

Properties
file_datastringoptional

The base64 encoded file data, used when passing the file to the model as a string.

file_idstringoptional

The ID of an uploaded file to use as input.

filenamestringoptional

The name of the file, used when passing the file to the model as a string.

file_urlstringoptional

The URL of the file, used when passing the file to the model as a URL.

tool_call_idstring*required

The ID of the tool call that this message is responding to.

AssistantMessageobject

Messages sent by the model in response to user messages.

Properties
role"assistant"*required
contentunionoptional

Rich content.

Variants
RichContentTextstring

Plain text content.

RichContentPartsarray

An array of rich content parts.

Items
TextRichContentPartobject

A text rich content part.

Properties
type"text"*required
textstring*required

The text content.

ImageRichContentPartobject

An image rich content part.

Properties
type"image_url"*required
image_urlobject*required

The URL of the image and its optional detail level.

Properties
urlstring*required

Either a URL of the image or the base64 encoded image data.

detailenumoptional

Specifies the detail level of the image.

Variants
"auto"
"low"
"high"
AudioRichContentPartobject

An audio rich content part.

Properties
type"input_audio"*required
input_audioobject*required

The audio data and its format.

Properties
datastring*required

Base64 encoded audio data.

formatenum*required

The format of the encoded audio data.

Variants
"wav"
"mp3"
VideoRichContentPartobject

A video rich content part.

Properties
typeenum*required
Variants
"video_url"
"input_video"
video_urlobject*required
Properties
urlstring*required

URL of the video.

FileRichContentPartobject

A file rich content part.

Properties
type"file"*required
fileobject*required

The file to be used as input, either as base64 data, an uploaded file ID, or a URL.

Properties
file_datastringoptional

The base64 encoded file data, used when passing the file to the model as a string.

file_idstringoptional

The ID of an uploaded file to use as input.

filenamestringoptional

The name of the file, used when passing the file to the model as a string.

file_urlstringoptional

The URL of the file, used when passing the file to the model as a URL.

namestringoptional

An optional name for the participant. Provides the model information to differentiate between participants of the same role.

refusalstringoptional

The refusal message by the assistant.

tool_callsarrayoptional

Tool calls made by the assistant.

Items
AssistantMessageToolCallFunctionobject

A function tool call made by the assistant.

Properties
type"function"*required
idstring*required

The unique identifier for the tool call.

functionobject*required

The name and arguments of the function called.

Properties
namestring*required

The name of the function called.

argumentsstring*required

The arguments passed to the function.

reasoningstringoptional

The reasoning provided by the assistant.

suffix_messagesarrayoptional

A list of messages exchanged in a chat conversation. These will be appended to every prompt sent to this LLM. Useful for setting context or influencing behavior.

Items
DeveloperMessageobject

Developer-provided instructions that the model should follow, regardless of messages sent by the user.

Properties
role"developer"*required
contentunion*required

Simple content.

Variants
SimpleContentTextstring

Plain text content.

SimpleContentPartsarray

An array of simple content parts.

Items
SimpleContentPartobject

A simple content part.

Properties
type"text"*required
textstring*required

The text content.

namestringoptional

An optional name for the participant. Provides the model information to differentiate between participants of the same role.

SystemMessageobject

Developer-provided instructions that the model should follow, regardless of messages sent by the user.

Properties
role"system"*required
contentunion*required

Simple content.

Variants
SimpleContentTextstring

Plain text content.

SimpleContentPartsarray

An array of simple content parts.

Items
SimpleContentPartobject

A simple content part.

Properties
type"text"*required
textstring*required

The text content.

namestringoptional

An optional name for the participant. Provides the model information to differentiate between participants of the same role.

UserMessageobject

Messages sent by an end user, containing prompts or additional context information.

Properties
role"user"*required
contentunion*required

Rich content.

Variants
RichContentTextstring

Plain text content.

RichContentPartsarray

An array of rich content parts.

Items
TextRichContentPartobject

A text rich content part.

Properties
type"text"*required
textstring*required

The text content.

ImageRichContentPartobject

An image rich content part.

Properties
type"image_url"*required
image_urlobject*required

The URL of the image and its optional detail level.

Properties
urlstring*required

Either a URL of the image or the base64 encoded image data.

detailenumoptional

Specifies the detail level of the image.

Variants
"auto"
"low"
"high"
AudioRichContentPartobject

An audio rich content part.

Properties
type"input_audio"*required
input_audioobject*required

The audio data and its format.

Properties
datastring*required

Base64 encoded audio data.

formatenum*required

The format of the encoded audio data.

Variants
"wav"
"mp3"
VideoRichContentPartobject

A video rich content part.

Properties
typeenum*required
Variants
"video_url"
"input_video"
video_urlobject*required
Properties
urlstring*required

URL of the video.

FileRichContentPartobject

A file rich content part.

Properties
type"file"*required
fileobject*required

The file to be used as input, either as base64 data, an uploaded file ID, or a URL.

Properties
file_datastringoptional

The base64 encoded file data, used when passing the file to the model as a string.

file_idstringoptional

The ID of an uploaded file to use as input.

filenamestringoptional

The name of the file, used when passing the file to the model as a string.

file_urlstringoptional

The URL of the file, used when passing the file to the model as a URL.

namestringoptional

An optional name for the participant. Provides the model information to differentiate between participants of the same role.

ToolMessageobject

Messages sent by tools in response to tool calls made by the assistant.

Properties
role"tool"*required
contentunion*required

Rich content.

Variants
RichContentTextstring

Plain text content.

RichContentPartsarray

An array of rich content parts.

Items
TextRichContentPartobject

A text rich content part.

Properties
type"text"*required
textstring*required

The text content.

ImageRichContentPartobject

An image rich content part.

Properties
type"image_url"*required
image_urlobject*required

The URL of the image and its optional detail level.

Properties
urlstring*required

Either a URL of the image or the base64 encoded image data.

detailenumoptional

Specifies the detail level of the image.

Variants
"auto"
"low"
"high"
AudioRichContentPartobject

An audio rich content part.

Properties
type"input_audio"*required
input_audioobject*required

The audio data and its format.

Properties
datastring*required

Base64 encoded audio data.

formatenum*required

The format of the encoded audio data.

Variants
"wav"
"mp3"
VideoRichContentPartobject

A video rich content part.

Properties
typeenum*required
Variants
"video_url"
"input_video"
video_urlobject*required
Properties
urlstring*required

URL of the video.

FileRichContentPartobject

A file rich content part.

Properties
type"file"*required
fileobject*required

The file to be used as input, either as base64 data, an uploaded file ID, or a URL.

Properties
file_datastringoptional

The base64 encoded file data, used when passing the file to the model as a string.

file_idstringoptional

The ID of an uploaded file to use as input.

filenamestringoptional

The name of the file, used when passing the file to the model as a string.

file_urlstringoptional

The URL of the file, used when passing the file to the model as a URL.

tool_call_idstring*required

The ID of the tool call that this message is responding to.

AssistantMessageobject

Messages sent by the model in response to user messages.

Properties
role"assistant"*required
contentunionoptional

Rich content.

Variants
RichContentTextstring

Plain text content.

RichContentPartsarray

An array of rich content parts.

Items
TextRichContentPartobject

A text rich content part.

Properties
type"text"*required
textstring*required

The text content.

ImageRichContentPartobject

An image rich content part.

Properties
type"image_url"*required
image_urlobject*required

The URL of the image and its optional detail level.

Properties
urlstring*required

Either a URL of the image or the base64 encoded image data.

detailenumoptional

Specifies the detail level of the image.

Variants
"auto"
"low"
"high"
AudioRichContentPartobject

An audio rich content part.

Properties
type"input_audio"*required
input_audioobject*required

The audio data and its format.

Properties
datastring*required

Base64 encoded audio data.

formatenum*required

The format of the encoded audio data.

Variants
"wav"
"mp3"
VideoRichContentPartobject

A video rich content part.

Properties
typeenum*required
Variants
"video_url"
"input_video"
video_urlobject*required
Properties
urlstring*required

URL of the video.

FileRichContentPartobject

A file rich content part.

Properties
type"file"*required
fileobject*required

The file to be used as input, either as base64 data, an uploaded file ID, or a URL.

Properties
file_datastringoptional

The base64 encoded file data, used when passing the file to the model as a string.

file_idstringoptional

The ID of an uploaded file to use as input.

filenamestringoptional

The name of the file, used when passing the file to the model as a string.

file_urlstringoptional

The URL of the file, used when passing the file to the model as a URL.

namestringoptional

An optional name for the participant. Provides the model information to differentiate between participants of the same role.

refusalstringoptional

The refusal message by the assistant.

tool_callsarrayoptional

Tool calls made by the assistant.

Items
AssistantMessageToolCallFunctionobject

A function tool call made by the assistant.

Properties
type"function"*required
idstring*required

The unique identifier for the tool call.

functionobject*required

The name and arguments of the function called.

Properties
namestring*required

The name of the function called.

argumentsstring*required

The arguments passed to the function.

reasoningstringoptional

The reasoning provided by the assistant.

frequency_penaltynumbermin: -2max: 2optional

This setting aims to control the repetition of tokens based on how often they appear in the input. It tries to use less frequently those tokens that appear more in the input, proportional to how frequently they occur. Token penalty scales with the number of occurrences. Negative values will encourage token reuse.

logit_biasrecordoptional

Accepts a JSON object that maps tokens (specified by their token ID in the tokenizer) to an associated bias value from -100 to 100. Mathematically, the bias is added to the logits generated by the model prior to sampling. The exact effect will vary per model, but values between -1 and 1 should decrease or increase likelihood of selection; values like -100 or 100 should result in a ban or exclusive selection of the relevant token.

Values
numbermin: -100max: 100
max_completion_tokensnumbermin: 0max: 2147483647optional

An upper bound for the number of tokens that can be generated for a completion, including visible output tokens and reasoning tokens.

presence_penaltynumbermin: -2max: 2optional

This setting aims to control the presence of tokens in the output. It tries to encourage the model to use tokens that are less present in the input, proportional to their presence in the input. Token presence scales with the number of occurrences. Negative values will encourage more diverse token usage.

stopunionoptional

The assistant will stop when any of the provided strings are generated.

Variants
StopStringstring

Generation will stop when this string is generated.

StopStringsarray

Generation will stop when any of these strings are generated.

Items
StopStringstring
temperaturenumbermin: 0max: 2optional

This setting influences the variety in the model’s responses. Lower values lead to more predictable and typical responses, while higher values encourage more diverse and less common responses. At 0, the model always gives the same response for a given input.

top_pnumbermin: 0max: 1optional

This setting limits the model’s choices to a percentage of likely tokens: only the top tokens whose probabilities add up to P. A lower value makes the model’s responses more predictable, while the default setting allows for a full range of token choices. Think of it like a dynamic Top-K.

max_tokensnumbermin: 0max: 2147483647optional

This sets the upper limit for the number of tokens the model can generate in response. It won’t produce more than this limit. The maximum value is the context length minus the prompt length.

min_pnumbermin: 0max: 1optional

Represents the minimum probability for a token to be considered, relative to the probability of the most likely token. (The value changes depending on the confidence level of the most probable token.) If your Min-P is set to 0.1, that means it will only allow for tokens that are at least 1/10th as probable as the best possible option.

providerobjectoptional

Options for selecting the upstream provider of this model.

Properties
allow_fallbacksbooleanoptional

Whether to allow fallback providers if the preferred provider is unavailable.

require_parametersbooleanoptional

Whether to require that the provider supports all specified parameters.

orderarrayoptional

An ordered list of provider names to use when selecting a provider for this model.

Items
ProviderNamestring
onlyarrayoptional

A list of provider names to restrict selection to when selecting a provider for this model.

Items
ProviderNamestring
ignorearrayoptional

A list of provider names to ignore when selecting a provider for this model.

Items
ProviderNamestring
quantizationsarrayoptional

Specifies the quantizations to allow when selecting providers for this model.

Items
"int4"
"int8"
"fp4"
"fp6"
"fp8"
"fp16"
"bf16"
"fp32"
"unknown"
reasoningobjectoptional

Options for controlling reasoning behavior of the model.

Properties
enabledbooleanoptional

Enables or disables reasoning for supported models.

max_tokensnumbermin: 0max: 2147483647optional

The maximum number of tokens to use for reasoning in a response.

effortenumoptional

Constrains effort on reasoning for supported reasoning models. Reducing reasoning effort can result in faster responses and fewer tokens used on reasoning in a response.

Variants
"none"
"minimal"
"low"
"medium"
"high"
"xhigh"
summary_verbosityenumoptional

Controls the verbosity of the reasoning summary for supported reasoning models.

Variants
"auto"
"concise"
"detailed"
repetition_penaltynumbermin: 0max: 2optional

Helps to reduce the repetition of tokens from the input. A higher value makes the model less likely to repeat tokens, but too high a value can make the output less coherent (often with run-on sentences that lack small words). Token penalty scales based on original token’s probability.

top_anumbermin: 0max: 1optional

Consider only the top tokens with “sufficiently high” probabilities based on the probability of the most likely token. Think of it like a dynamic Top-P. A lower Top-A value focuses the choices based on the highest probability token but with a narrower scope. A higher Top-A value does not necessarily affect the creativity of the output, but rather refines the filtering process based on the maximum probability.

top_knumbermin: 0max: 2147483647optional

This limits the model’s choice of tokens at each step, making it choose from a smaller set. A value of 1 means the model will always pick the most likely next token, leading to predictable results. By default this setting is disabled, making the model to consider all choices.

verbosityenumoptional

Controls the verbosity and length of the model response. Lower values produce more concise responses, while higher values produce more detailed and comprehensive responses.

Variants
"low"
"medium"
"high"
"max"
modelsarrayoptional

Fallback Ensemble LLMs to use if the primary Ensemble LLM fails.

Items
EnsembleLlmIdstring

The unique identifier for the Ensemble LLM.

EnsembleLlmBaseobject

An LLM to be used within an Ensemble or standalone with Chat Completions.

Properties
modelstring*required

The full ID of the LLM to use.

output_modeenum*required

For Vector Completions only, specifies the LLM's voting output mode. For "instruction", the assistant is instructed to output a key. For "json_schema", the assistant is constrained to output a valid key using a JSON schema. For "tool_call", the assistant is instructed to output a tool call to select the key.

Variants
"instruction"
"json_schema"
"tool_call"
synthetic_reasoningbooleanoptional

For Vector Completions only, whether to use synthetic reasoning prior to voting. Works for any LLM, even those that do not have native reasoning capabilities.

top_logprobsnumbermin: 0max: 20optional

For Vector Completions only, whether to use logprobs to make the vote probabilistic. This means that the LLM can vote for multiple keys based on their logprobabilities. Allows LLMs to express native uncertainty when voting.

prefix_messagesarrayoptional

A list of messages exchanged in a chat conversation. These will be prepended to every prompt sent to this LLM. Useful for setting context or influencing behavior.

Items
DeveloperMessageobject

Developer-provided instructions that the model should follow, regardless of messages sent by the user.

Properties
role"developer"*required
contentunion*required

Simple content.

Variants
SimpleContentTextstring

Plain text content.

SimpleContentPartsarray

An array of simple content parts.

Items
SimpleContentPartobject

A simple content part.

Properties
type"text"*required
textstring*required

The text content.

namestringoptional

An optional name for the participant. Provides the model information to differentiate between participants of the same role.

SystemMessageobject

Developer-provided instructions that the model should follow, regardless of messages sent by the user.

Properties
role"system"*required
contentunion*required

Simple content.

Variants
SimpleContentTextstring

Plain text content.

SimpleContentPartsarray

An array of simple content parts.

Items
SimpleContentPartobject

A simple content part.

Properties
type"text"*required
textstring*required

The text content.

namestringoptional

An optional name for the participant. Provides the model information to differentiate between participants of the same role.

UserMessageobject

Messages sent by an end user, containing prompts or additional context information.

Properties
role"user"*required
contentunion*required

Rich content.

Variants
RichContentTextstring

Plain text content.

RichContentPartsarray

An array of rich content parts.

Items
TextRichContentPartobject

A text rich content part.

Properties
type"text"*required
textstring*required

The text content.

ImageRichContentPartobject

An image rich content part.

Properties
type"image_url"*required
image_urlobject*required

The URL of the image and its optional detail level.

Properties
urlstring*required

Either a URL of the image or the base64 encoded image data.

detailenumoptional

Specifies the detail level of the image.

Variants
"auto"
"low"
"high"
AudioRichContentPartobject

An audio rich content part.

Properties
type"input_audio"*required
input_audioobject*required

The audio data and its format.

Properties
datastring*required

Base64 encoded audio data.

formatenum*required

The format of the encoded audio data.

Variants
"wav"
"mp3"
VideoRichContentPartobject

A video rich content part.

Properties
typeenum*required
Variants
"video_url"
"input_video"
video_urlobject*required
Properties
urlstring*required

URL of the video.

FileRichContentPartobject

A file rich content part.

Properties
type"file"*required
fileobject*required

The file to be used as input, either as base64 data, an uploaded file ID, or a URL.

Properties
file_datastringoptional

The base64 encoded file data, used when passing the file to the model as a string.

file_idstringoptional

The ID of an uploaded file to use as input.

filenamestringoptional

The name of the file, used when passing the file to the model as a string.

file_urlstringoptional

The URL of the file, used when passing the file to the model as a URL.

namestringoptional

An optional name for the participant. Provides the model information to differentiate between participants of the same role.

ToolMessageobject

Messages sent by tools in response to tool calls made by the assistant.

Properties
role"tool"*required
contentunion*required

Rich content.

Variants
RichContentTextstring

Plain text content.

RichContentPartsarray

An array of rich content parts.

Items
TextRichContentPartobject

A text rich content part.

Properties
type"text"*required
textstring*required

The text content.

ImageRichContentPartobject

An image rich content part.

Properties
type"image_url"*required
image_urlobject*required

The URL of the image and its optional detail level.

Properties
urlstring*required

Either a URL of the image or the base64 encoded image data.

detailenumoptional

Specifies the detail level of the image.

Variants
"auto"
"low"
"high"
AudioRichContentPartobject

An audio rich content part.

Properties
type"input_audio"*required
input_audioobject*required

The audio data and its format.

Properties
datastring*required

Base64 encoded audio data.

formatenum*required

The format of the encoded audio data.

Variants
"wav"
"mp3"
VideoRichContentPartobject

A video rich content part.

Properties
typeenum*required
Variants
"video_url"
"input_video"
video_urlobject*required
Properties
urlstring*required

URL of the video.

FileRichContentPartobject

A file rich content part.

Properties
type"file"*required
fileobject*required

The file to be used as input, either as base64 data, an uploaded file ID, or a URL.

Properties
file_datastringoptional

The base64 encoded file data, used when passing the file to the model as a string.

file_idstringoptional

The ID of an uploaded file to use as input.

filenamestringoptional

The name of the file, used when passing the file to the model as a string.

file_urlstringoptional

The URL of the file, used when passing the file to the model as a URL.

tool_call_idstring*required

The ID of the tool call that this message is responding to.

AssistantMessageobject

Messages sent by the model in response to user messages.

Properties
role"assistant"*required
contentunionoptional

Rich content.

Variants
RichContentTextstring

Plain text content.

RichContentPartsarray

An array of rich content parts.

Items
TextRichContentPartobject

A text rich content part.

Properties
type"text"*required
textstring*required

The text content.

ImageRichContentPartobject

An image rich content part.

Properties
type"image_url"*required
image_urlobject*required

The URL of the image and its optional detail level.

Properties
urlstring*required

Either a URL of the image or the base64 encoded image data.

detailenumoptional

Specifies the detail level of the image.

Variants
"auto"
"low"
"high"
AudioRichContentPartobject

An audio rich content part.

Properties
type"input_audio"*required
input_audioobject*required

The audio data and its format.

Properties
datastring*required

Base64 encoded audio data.

formatenum*required

The format of the encoded audio data.

Variants
"wav"
"mp3"
VideoRichContentPartobject

A video rich content part.

Properties
typeenum*required
Variants
"video_url"
"input_video"
video_urlobject*required
Properties
urlstring*required

URL of the video.

FileRichContentPartobject

A file rich content part.

Properties
type"file"*required
fileobject*required

The file to be used as input, either as base64 data, an uploaded file ID, or a URL.

Properties
file_datastringoptional

The base64 encoded file data, used when passing the file to the model as a string.

file_idstringoptional

The ID of an uploaded file to use as input.

filenamestringoptional

The name of the file, used when passing the file to the model as a string.

file_urlstringoptional

The URL of the file, used when passing the file to the model as a URL.

namestringoptional

An optional name for the participant. Provides the model information to differentiate between participants of the same role.

refusalstringoptional

The refusal message by the assistant.

tool_callsarrayoptional

Tool calls made by the assistant.

Items
AssistantMessageToolCallFunctionobject

A function tool call made by the assistant.

Properties
type"function"*required
idstring*required

The unique identifier for the tool call.

functionobject*required

The name and arguments of the function called.

Properties
namestring*required

The name of the function called.

argumentsstring*required

The arguments passed to the function.

reasoningstringoptional

The reasoning provided by the assistant.

suffix_messagesarrayoptional

A list of messages exchanged in a chat conversation. These will be appended to every prompt sent to this LLM. Useful for setting context or influencing behavior.

Items
DeveloperMessageobject

Developer-provided instructions that the model should follow, regardless of messages sent by the user.

Properties
role"developer"*required
contentunion*required

Simple content.

Variants
SimpleContentTextstring

Plain text content.

SimpleContentPartsarray

An array of simple content parts.

Items
SimpleContentPartobject

A simple content part.

Properties
type"text"*required
textstring*required

The text content.

namestringoptional

An optional name for the participant. Provides the model information to differentiate between participants of the same role.

SystemMessageobject

Developer-provided instructions that the model should follow, regardless of messages sent by the user.

Properties
role"system"*required
contentunion*required

Simple content.

Variants
SimpleContentTextstring

Plain text content.

SimpleContentPartsarray

An array of simple content parts.

Items
SimpleContentPartobject

A simple content part.

Properties
type"text"*required
textstring*required

The text content.

namestringoptional

An optional name for the participant. Provides the model information to differentiate between participants of the same role.

UserMessageobject

Messages sent by an end user, containing prompts or additional context information.

Properties
role"user"*required
contentunion*required

Rich content.

Variants
RichContentTextstring

Plain text content.

RichContentPartsarray

An array of rich content parts.

Items
TextRichContentPartobject

A text rich content part.

Properties
type"text"*required
textstring*required

The text content.

ImageRichContentPartobject

An image rich content part.

Properties
type"image_url"*required
image_urlobject*required

The URL of the image and its optional detail level.

Properties
urlstring*required

Either a URL of the image or the base64 encoded image data.

detailenumoptional

Specifies the detail level of the image.

Variants
"auto"
"low"
"high"
AudioRichContentPartobject

An audio rich content part.

Properties
type"input_audio"*required
input_audioobject*required

The audio data and its format.

Properties
datastring*required

Base64 encoded audio data.

formatenum*required

The format of the encoded audio data.

Variants
"wav"
"mp3"
VideoRichContentPartobject

A video rich content part.

Properties
typeenum*required
Variants
"video_url"
"input_video"
video_urlobject*required
Properties
urlstring*required

URL of the video.

FileRichContentPartobject

A file rich content part.

Properties
type"file"*required
fileobject*required

The file to be used as input, either as base64 data, an uploaded file ID, or a URL.

Properties
file_datastringoptional

The base64 encoded file data, used when passing the file to the model as a string.

file_idstringoptional

The ID of an uploaded file to use as input.

filenamestringoptional

The name of the file, used when passing the file to the model as a string.

file_urlstringoptional

The URL of the file, used when passing the file to the model as a URL.

namestringoptional

An optional name for the participant. Provides the model information to differentiate between participants of the same role.

ToolMessageobject

Messages sent by tools in response to tool calls made by the assistant.

Properties
role"tool"*required
contentunion*required

Rich content.

Variants
RichContentTextstring

Plain text content.

RichContentPartsarray

An array of rich content parts.

Items
TextRichContentPartobject

A text rich content part.

Properties
type"text"*required
textstring*required

The text content.

ImageRichContentPartobject

An image rich content part.

Properties
type"image_url"*required
image_urlobject*required

The URL of the image and its optional detail level.

Properties
urlstring*required

Either a URL of the image or the base64 encoded image data.

detailenumoptional

Specifies the detail level of the image.

Variants
"auto"
"low"
"high"
AudioRichContentPartobject

An audio rich content part.

Properties
type"input_audio"*required
input_audioobject*required

The audio data and its format.

Properties
datastring*required

Base64 encoded audio data.

formatenum*required

The format of the encoded audio data.

Variants
"wav"
"mp3"
VideoRichContentPartobject

A video rich content part.

Properties
typeenum*required
Variants
"video_url"
"input_video"
video_urlobject*required
Properties
urlstring*required

URL of the video.

FileRichContentPartobject

A file rich content part.

Properties
type"file"*required
fileobject*required

The file to be used as input, either as base64 data, an uploaded file ID, or a URL.

Properties
file_datastringoptional

The base64 encoded file data, used when passing the file to the model as a string.

file_idstringoptional

The ID of an uploaded file to use as input.

filenamestringoptional

The name of the file, used when passing the file to the model as a string.

file_urlstringoptional

The URL of the file, used when passing the file to the model as a URL.

tool_call_idstring*required

The ID of the tool call that this message is responding to.

AssistantMessageobject

Messages sent by the model in response to user messages.

Properties
role"assistant"*required
contentunionoptional

Rich content.

Variants
RichContentTextstring

Plain text content.

RichContentPartsarray

An array of rich content parts.

Items
TextRichContentPartobject

A text rich content part.

Properties
type"text"*required
textstring*required

The text content.

ImageRichContentPartobject

An image rich content part.

Properties
type"image_url"*required
image_urlobject*required

The URL of the image and its optional detail level.

Properties
urlstring*required

Either a URL of the image or the base64 encoded image data.

detailenumoptional

Specifies the detail level of the image.

Variants
"auto"
"low"
"high"
AudioRichContentPartobject

An audio rich content part.

Properties
type"input_audio"*required
input_audioobject*required

The audio data and its format.

Properties
datastring*required

Base64 encoded audio data.

formatenum*required

The format of the encoded audio data.

Variants
"wav"
"mp3"
VideoRichContentPartobject

A video rich content part.

Properties
typeenum*required
Variants
"video_url"
"input_video"
video_urlobject*required
Properties
urlstring*required

URL of the video.

FileRichContentPartobject

A file rich content part.

Properties
type"file"*required
fileobject*required

The file to be used as input, either as base64 data, an uploaded file ID, or a URL.

Properties
file_datastringoptional

The base64 encoded file data, used when passing the file to the model as a string.

file_idstringoptional

The ID of an uploaded file to use as input.

filenamestringoptional

The name of the file, used when passing the file to the model as a string.

file_urlstringoptional

The URL of the file, used when passing the file to the model as a URL.

namestringoptional

An optional name for the participant. Provides the model information to differentiate between participants of the same role.

refusalstringoptional

The refusal message by the assistant.

tool_callsarrayoptional

Tool calls made by the assistant.

Items
AssistantMessageToolCallFunctionobject

A function tool call made by the assistant.

Properties
type"function"*required
idstring*required

The unique identifier for the tool call.

functionobject*required

The name and arguments of the function called.

Properties
namestring*required

The name of the function called.

argumentsstring*required

The arguments passed to the function.

reasoningstringoptional

The reasoning provided by the assistant.

frequency_penaltynumbermin: -2max: 2optional

This setting aims to control the repetition of tokens based on how often they appear in the input. It tries to use less frequently those tokens that appear more in the input, proportional to how frequently they occur. Token penalty scales with the number of occurrences. Negative values will encourage token reuse.

logit_biasrecordoptional

Accepts a JSON object that maps tokens (specified by their token ID in the tokenizer) to an associated bias value from -100 to 100. Mathematically, the bias is added to the logits generated by the model prior to sampling. The exact effect will vary per model, but values between -1 and 1 should decrease or increase likelihood of selection; values like -100 or 100 should result in a ban or exclusive selection of the relevant token.

Values
numbermin: -100max: 100
max_completion_tokensnumbermin: 0max: 2147483647optional

An upper bound for the number of tokens that can be generated for a completion, including visible output tokens and reasoning tokens.

presence_penaltynumbermin: -2max: 2optional

This setting aims to control the presence of tokens in the output. It tries to encourage the model to use tokens that are less present in the input, proportional to their presence in the input. Token presence scales with the number of occurrences. Negative values will encourage more diverse token usage.

stopunionoptional

The assistant will stop when any of the provided strings are generated.

Variants
StopStringstring

Generation will stop when this string is generated.

StopStringsarray

Generation will stop when any of these strings are generated.

Items
StopStringstring
temperaturenumbermin: 0max: 2optional

This setting influences the variety in the model’s responses. Lower values lead to more predictable and typical responses, while higher values encourage more diverse and less common responses. At 0, the model always gives the same response for a given input.

top_pnumbermin: 0max: 1optional

This setting limits the model’s choices to a percentage of likely tokens: only the top tokens whose probabilities add up to P. A lower value makes the model’s responses more predictable, while the default setting allows for a full range of token choices. Think of it like a dynamic Top-K.

max_tokensnumbermin: 0max: 2147483647optional

This sets the upper limit for the number of tokens the model can generate in response. It won’t produce more than this limit. The maximum value is the context length minus the prompt length.

min_pnumbermin: 0max: 1optional

Represents the minimum probability for a token to be considered, relative to the probability of the most likely token. (The value changes depending on the confidence level of the most probable token.) If your Min-P is set to 0.1, that means it will only allow for tokens that are at least 1/10th as probable as the best possible option.

providerobjectoptional

Options for selecting the upstream provider of this model.

Properties
allow_fallbacksbooleanoptional

Whether to allow fallback providers if the preferred provider is unavailable.

require_parametersbooleanoptional

Whether to require that the provider supports all specified parameters.

orderarrayoptional

An ordered list of provider names to use when selecting a provider for this model.

Items
ProviderNamestring
onlyarrayoptional

A list of provider names to restrict selection to when selecting a provider for this model.

Items
ProviderNamestring
ignorearrayoptional

A list of provider names to ignore when selecting a provider for this model.

Items
ProviderNamestring
quantizationsarrayoptional

Specifies the quantizations to allow when selecting providers for this model.

Items
"int4"
"int8"
"fp4"
"fp6"
"fp8"
"fp16"
"bf16"
"fp32"
"unknown"
reasoningobjectoptional

Options for controlling reasoning behavior of the model.

Properties
enabledbooleanoptional

Enables or disables reasoning for supported models.

max_tokensnumbermin: 0max: 2147483647optional

The maximum number of tokens to use for reasoning in a response.

effortenumoptional

Constrains effort on reasoning for supported reasoning models. Reducing reasoning effort can result in faster responses and fewer tokens used on reasoning in a response.

Variants
"none"
"minimal"
"low"
"medium"
"high"
"xhigh"
summary_verbosityenumoptional

Controls the verbosity of the reasoning summary for supported reasoning models.

Variants
"auto"
"concise"
"detailed"
repetition_penaltynumbermin: 0max: 2optional

Helps to reduce the repetition of tokens from the input. A higher value makes the model less likely to repeat tokens, but too high a value can make the output less coherent (often with run-on sentences that lack small words). Token penalty scales based on original token’s probability.

top_anumbermin: 0max: 1optional

Consider only the top tokens with “sufficiently high” probabilities based on the probability of the most likely token. Think of it like a dynamic Top-P. A lower Top-A value focuses the choices based on the highest probability token but with a narrower scope. A higher Top-A value does not necessarily affect the creativity of the output, but rather refines the filtering process based on the maximum probability.

top_knumbermin: 0max: 2147483647optional

This limits the model’s choice of tokens at each step, making it choose from a smaller set. A value of 1 means the model will always pick the most likely next token, leading to predictable results. By default this setting is disabled, making the model to consider all choices.

verbosityenumoptional

Controls the verbosity and length of the model response. Lower values produce more concise responses, while higher values produce more detailed and comprehensive responses.

Variants
"low"
"medium"
"high"
"max"
inputunion*required

A value provided as input to a function.

Variants
ImageRichContentPartobject

An image rich content part.

Properties
type"image_url"*required
image_urlobject*required

The URL of the image and its optional detail level.

Properties
urlstring*required

Either a URL of the image or the base64 encoded image data.

detailenumoptional

Specifies the detail level of the image.

Variants
"auto"
"low"
"high"
AudioRichContentPartobject

An audio rich content part.

Properties
type"input_audio"*required
input_audioobject*required

The audio data and its format.

Properties
datastring*required

Base64 encoded audio data.

formatenum*required

The format of the encoded audio data.

Variants
"wav"
"mp3"
VideoRichContentPartobject

A video rich content part.

Properties
typeenum*required
Variants
"video_url"
"input_video"
video_urlobject*required
Properties
urlstring*required

URL of the video.

FileRichContentPartobject

A file rich content part.

Properties
type"file"*required
fileobject*required

The file to be used as input, either as base64 data, an uploaded file ID, or a URL.

Properties
file_datastringoptional

The base64 encoded file data, used when passing the file to the model as a string.

file_idstringoptional

The ID of an uploaded file to use as input.

filenamestringoptional

The name of the file, used when passing the file to the model as a string.

file_urlstringoptional

The URL of the file, used when passing the file to the model as a URL.

record
Values
InputValueoptional
array
Items
InputValue
string
number
boolean
providerobjectoptional

Options for selecting the upstream provider of this completion.

Properties
data_collectionenumoptional

Specifies whether to allow providers which collect data.

Variants
"allow"
"deny"
zdrbooleanoptional

Whether to enforce Zero Data Retention (ZDR) policies when selecting providers.

sortenumoptional

Specifies the sorting strategy for provider selection.

Variants
"price"
"throughput"
"latency"
max_priceobjectoptional
Properties
promptnumberoptional

Maximum price for prompt tokens.

completionnumberoptional

Maximum price for completion tokens.

imagenumberoptional

Maximum price for image generation.

audionumberoptional

Maximum price for audio generation.

requestnumberoptional

Maximum price per request.

preferred_min_throughputnumberoptional

Preferred minimum throughput for the provider.

preferred_max_latencynumberoptional

Preferred maximum latency for the provider.

min_throughputnumberoptional

Minimum throughput for the provider.

max_latencynumberoptional

Maximum latency for the provider.

seedbigintoptional

If specified, upstream systems will make a best effort to sample deterministically, such that repeated requests with the same seed and parameters should return the same result.

backoff_max_elapsed_timenumbermin: 0max: 4294967295optional

The maximum total time in milliseconds to spend on retries when a transient error occurs.

first_chunk_timeoutnumbermin: 0max: 4294967295optional

The maximum time in milliseconds to wait for the first chunk of a streaming response.

other_chunk_timeoutnumbermin: 0max: 4294967295optional

The maximum time in milliseconds to wait between subsequent chunks of a streaming response.

functionunion*required

A function defined inline.

Variants
InlineScalarFunctionobject

A scalar function defined inline. Each task's output expression must return a number in [0,1]. The function's output is the weighted average of all task outputs using profile weights. If there is only one task, its output becomes the function's output directly.

Properties
type"scalar.function"*required
input_mapsunionoptional

Defines arrays used by mapped tasks. A task with `map: i` references the i-th sub-array. The task is compiled once per element in that sub-array, producing multiple task instances. If the sub-array is empty, no task instances are produced (effectively skipping the task). Each compiled instance's expressions receive the current element as `map`. Receives: `input`.

Variants
JMESPathExpressionobject

A JMESPath expression which evaluates to a value.

Properties
$jmespathstring*required

A JMESPath expression.

StarlarkExpressionobject

A Starlark expression which evaluates to a value.

Properties
$starlarkstring*required

A Starlark expression.

array

A list of expressions, each evaluating to a 1D array of Inputs. The i-th expression produces the i-th sub-array.

Items
JMESPathExpressionobject

A JMESPath expression which evaluates to a value.

Properties
$jmespathstring*required

A JMESPath expression.

StarlarkExpressionobject

A Starlark expression which evaluates to a value.

Properties
$starlarkstring*required

A Starlark expression.

tasksarray*required

The list of tasks to be executed as part of the function. Each will first be compiled using the parent function's input.

Items
ScalarFunctionTaskExpressionobject

A scalar function task expression.

Properties
type"scalar.function"*required
remoteenum*required

The remote source hosting the repository.

Variants
"github"
"filesystem"
ownerstring*required

The owner of the repository containing the function.

repositorystring*required

The name of the repository containing the function.

commitstring*required

The commit SHA of the repository containing the function.

skipunionoptional

An expression which evaluates to a boolean indicating whether to skip this task. Receives: `input`.

Variants
JMESPathExpressionobject

A JMESPath expression which evaluates to a value.

Properties
$jmespathstring*required

A JMESPath expression.

StarlarkExpressionobject

A Starlark expression which evaluates to a value.

Properties
$starlarkstring*required

A Starlark expression.

mapnumbermin: 0max: 4294967295optional

Index into the function's `input_maps` 2D array. When present, this task is compiled once per element in `input_maps[map]`, producing multiple task instances. Each compiled instance's expressions receive the current element as `map`.

inputunion*required

A value provided as input to a function.

Variants
ImageRichContentPartobject

An image rich content part.

Properties
type"image_url"*required
image_urlobject*required

The URL of the image and its optional detail level.

Properties
urlstring*required

Either a URL of the image or the base64 encoded image data.

detailenumoptional

Specifies the detail level of the image.

Variants
"auto"
"low"
"high"
AudioRichContentPartobject

An audio rich content part.

Properties
type"input_audio"*required
input_audioobject*required

The audio data and its format.

Properties
datastring*required

Base64 encoded audio data.

formatenum*required

The format of the encoded audio data.

Variants
"wav"
"mp3"
VideoRichContentPartobject

A video rich content part.

Properties
typeenum*required
Variants
"video_url"
"input_video"
video_urlobject*required
Properties
urlstring*required

URL of the video.

FileRichContentPartobject

A file rich content part.

Properties
type"file"*required
fileobject*required

The file to be used as input, either as base64 data, an uploaded file ID, or a URL.

Properties
file_datastringoptional

The base64 encoded file data, used when passing the file to the model as a string.

file_idstringoptional

The ID of an uploaded file to use as input.

filenamestringoptional

The name of the file, used when passing the file to the model as a string.

file_urlstringoptional

The URL of the file, used when passing the file to the model as a URL.

record
Values
InputValueExpression
array
Items
InputValueExpression
string
number
boolean
JMESPathExpressionobject

A JMESPath expression which evaluates to a value.

Properties
$jmespathstring*required

A JMESPath expression.

StarlarkExpressionobject

A Starlark expression which evaluates to a value.

Properties
$starlarkstring*required

A Starlark expression.

outputunion*required

An expression which transforms the task result into a FunctionOutput. Receives `output` as one of 4 variants depending on task type: a single FunctionOutput (for non-mapped function tasks), an array of FunctionOutputs (for mapped function tasks), a VectorCompletionOutput (for non-mapped vector completion tasks), or an array of VectorCompletionOutputs (for mapped vector completion tasks). Must return a FunctionOutput valid for the parent function's type: scalar functions require a number in [0,1], vector functions require an array of numbers summing to ~1. The function's final output is the weighted average of all task outputs using profile weights. Receives: `input`, `output`.

Variants
JMESPathExpressionobject

A JMESPath expression which evaluates to a value.

Properties
$jmespathstring*required

A JMESPath expression.

StarlarkExpressionobject

A Starlark expression which evaluates to a value.

Properties
$starlarkstring*required

A Starlark expression.

VectorFunctionTaskExpressionobject

A vector function task expression.

Properties
type"vector.function"*required
remoteenum*required

The remote source hosting the repository.

Variants
"github"
"filesystem"
ownerstring*required

The owner of the repository containing the function.

repositorystring*required

The name of the repository containing the function.

commitstring*required

The commit SHA of the repository containing the function.

skipunionoptional

An expression which evaluates to a boolean indicating whether to skip this task. Receives: `input`.

Variants
JMESPathExpressionobject

A JMESPath expression which evaluates to a value.

Properties
$jmespathstring*required

A JMESPath expression.

StarlarkExpressionobject

A Starlark expression which evaluates to a value.

Properties
$starlarkstring*required

A Starlark expression.

mapnumbermin: 0max: 4294967295optional

Index into the function's `input_maps` 2D array. When present, this task is compiled once per element in `input_maps[map]`, producing multiple task instances. Each compiled instance's expressions receive the current element as `map`.

inputunion*required

A value provided as input to a function.

Variants
ImageRichContentPartobject

An image rich content part.

Properties
type"image_url"*required
image_urlobject*required

The URL of the image and its optional detail level.

Properties
urlstring*required

Either a URL of the image or the base64 encoded image data.

detailenumoptional

Specifies the detail level of the image.

Variants
"auto"
"low"
"high"
AudioRichContentPartobject

An audio rich content part.

Properties
type"input_audio"*required
input_audioobject*required

The audio data and its format.

Properties
datastring*required

Base64 encoded audio data.

formatenum*required

The format of the encoded audio data.

Variants
"wav"
"mp3"
VideoRichContentPartobject

A video rich content part.

Properties
typeenum*required
Variants
"video_url"
"input_video"
video_urlobject*required
Properties
urlstring*required

URL of the video.

FileRichContentPartobject

A file rich content part.

Properties
type"file"*required
fileobject*required

The file to be used as input, either as base64 data, an uploaded file ID, or a URL.

Properties
file_datastringoptional

The base64 encoded file data, used when passing the file to the model as a string.

file_idstringoptional

The ID of an uploaded file to use as input.

filenamestringoptional

The name of the file, used when passing the file to the model as a string.

file_urlstringoptional

The URL of the file, used when passing the file to the model as a URL.

record
Values
InputValueExpression
array
Items
InputValueExpression
string
number
boolean
JMESPathExpressionobject

A JMESPath expression which evaluates to a value.

Properties
$jmespathstring*required

A JMESPath expression.

StarlarkExpressionobject

A Starlark expression which evaluates to a value.

Properties
$starlarkstring*required

A Starlark expression.

outputunion*required

An expression which transforms the task result into a FunctionOutput. Receives `output` as one of 4 variants depending on task type: a single FunctionOutput (for non-mapped function tasks), an array of FunctionOutputs (for mapped function tasks), a VectorCompletionOutput (for non-mapped vector completion tasks), or an array of VectorCompletionOutputs (for mapped vector completion tasks). Must return a FunctionOutput valid for the parent function's type: scalar functions require a number in [0,1], vector functions require an array of numbers summing to ~1. The function's final output is the weighted average of all task outputs using profile weights. Receives: `input`, `output`.

Variants
JMESPathExpressionobject

A JMESPath expression which evaluates to a value.

Properties
$jmespathstring*required

A JMESPath expression.

StarlarkExpressionobject

A Starlark expression which evaluates to a value.

Properties
$starlarkstring*required

A Starlark expression.

VectorCompletionTaskExpressionobject

A vector completion task expression.

Properties
type"vector.completion"*required
skipunionoptional

An expression which evaluates to a boolean indicating whether to skip this task. Receives: `input`.

Variants
JMESPathExpressionobject

A JMESPath expression which evaluates to a value.

Properties
$jmespathstring*required

A JMESPath expression.

StarlarkExpressionobject

A Starlark expression which evaluates to a value.

Properties
$starlarkstring*required

A Starlark expression.

mapnumbermin: 0max: 4294967295optional

Index into the function's `input_maps` 2D array. When present, this task is compiled once per element in `input_maps[map]`, producing multiple task instances. Each compiled instance's expressions receive the current element as `map`.

messagesunion*required

A list of messages exchanged in a chat conversation.

Variants
MessageExpressionsarray

A list of messages exchanged in a chat conversation.

Items
DeveloperMessageExpressionobject

Developer-provided instructions that the model should follow, regardless of messages sent by the user.

Properties
role"developer"*required
contentunion*required

Simple content.

Variants
SimpleContentTextstring

Plain text content.

SimpleContentPartExpressionsarray

An array of simple content parts.

Items
object
Properties
type"text"*required
textunion*required
Variants
string

The text content.

JMESPathExpressionobject

A JMESPath expression which evaluates to a value.

Properties
$jmespathstring*required

A JMESPath expression.

StarlarkExpressionobject

A Starlark expression which evaluates to a value.

Properties
$starlarkstring*required

A Starlark expression.

JMESPathExpressionobject

A JMESPath expression which evaluates to a value.

Properties
$jmespathstring*required

A JMESPath expression.

StarlarkExpressionobject

A Starlark expression which evaluates to a value.

Properties
$starlarkstring*required

A Starlark expression.

JMESPathExpressionobject

A JMESPath expression which evaluates to a value.

Properties
$jmespathstring*required

A JMESPath expression.

StarlarkExpressionobject

A Starlark expression which evaluates to a value.

Properties
$starlarkstring*required

A Starlark expression.

nameunionoptional

An optional name for the participant. Provides the model information to differentiate between participants of the same role.

Variants
MessageNamestring

An optional name for the participant. Provides the model information to differentiate between participants of the same role.

JMESPathExpressionobject

A JMESPath expression which evaluates to a value.

Properties
$jmespathstring*required

A JMESPath expression.

StarlarkExpressionobject

A Starlark expression which evaluates to a value.

Properties
$starlarkstring*required

A Starlark expression.

SystemMessageExpressionobject

Developer-provided instructions that the model should follow, regardless of messages sent by the user.

Properties
role"system"*required
contentunion*required

Simple content.

Variants
SimpleContentTextstring

Plain text content.

SimpleContentPartExpressionsarray

An array of simple content parts.

Items
object
Properties
type"text"*required
textunion*required
Variants
string

The text content.

JMESPathExpressionobject

A JMESPath expression which evaluates to a value.

Properties
$jmespathstring*required

A JMESPath expression.

StarlarkExpressionobject

A Starlark expression which evaluates to a value.

Properties
$starlarkstring*required

A Starlark expression.

JMESPathExpressionobject

A JMESPath expression which evaluates to a value.

Properties
$jmespathstring*required

A JMESPath expression.

StarlarkExpressionobject

A Starlark expression which evaluates to a value.

Properties
$starlarkstring*required

A Starlark expression.

JMESPathExpressionobject

A JMESPath expression which evaluates to a value.

Properties
$jmespathstring*required

A JMESPath expression.

StarlarkExpressionobject

A Starlark expression which evaluates to a value.

Properties
$starlarkstring*required

A Starlark expression.

nameunionoptional

An optional name for the participant. Provides the model information to differentiate between participants of the same role.

Variants
MessageNamestring

An optional name for the participant. Provides the model information to differentiate between participants of the same role.

JMESPathExpressionobject

A JMESPath expression which evaluates to a value.

Properties
$jmespathstring*required

A JMESPath expression.

StarlarkExpressionobject

A Starlark expression which evaluates to a value.

Properties
$starlarkstring*required

A Starlark expression.

UserMessageExpressionobject

Messages sent by an end user, containing prompts or additional context information.

Properties
role"user"*required
contentunion*required

Rich content.

Variants
RichContentTextstring

Plain text content.

RichContentPartExpressionsarray

An array of rich content parts.

Items
TextRichContentPartExpressionobject

A text rich content part.

Properties
type"text"*required
textunion*required

The text content.

Variants
string

The text content.

JMESPathExpressionobject

A JMESPath expression which evaluates to a value.

Properties
$jmespathstring*required

A JMESPath expression.

StarlarkExpressionobject

A Starlark expression which evaluates to a value.

Properties
$starlarkstring*required

A Starlark expression.

ImageRichContentPartExpressionobject

An image rich content part.

Properties
type"image_url"*required
image_urlunion*required

The URL of the image and its optional detail level.

Variants
object

The URL of the image and its optional detail level.

Properties
urlstring*required

Either a URL of the image or the base64 encoded image data.

detailenumoptional

Specifies the detail level of the image.

Variants
"auto"
"low"
"high"
JMESPathExpressionobject

A JMESPath expression which evaluates to a value.

Properties
$jmespathstring*required

A JMESPath expression.

StarlarkExpressionobject

A Starlark expression which evaluates to a value.

Properties
$starlarkstring*required

A Starlark expression.

AudioRichContentPartExpressionobject

An audio rich content part.

Properties
type"input_audio"*required
input_audiounion*required

The audio data and its format.

Variants
object

The audio data and its format.

Properties
datastring*required

Base64 encoded audio data.

formatenum*required

The format of the encoded audio data.

Variants
"wav"
"mp3"
JMESPathExpressionobject

A JMESPath expression which evaluates to a value.

Properties
$jmespathstring*required

A JMESPath expression.

StarlarkExpressionobject

A Starlark expression which evaluates to a value.

Properties
$starlarkstring*required

A Starlark expression.

VideoRichContentPartExpressionobject

A video rich content part.

Properties
typeenum*required
Variants
"video_url"
"input_video"
video_urlunion*required

The video URL definition.

Variants
object
Properties
urlstring*required

URL of the video.

JMESPathExpressionobject

A JMESPath expression which evaluates to a value.

Properties
$jmespathstring*required

A JMESPath expression.

StarlarkExpressionobject

A Starlark expression which evaluates to a value.

Properties
$starlarkstring*required

A Starlark expression.

FileRichContentPartExpressionobject

A file rich content part.

Properties
type"file"*required
fileunion*required

The file to be used as input, either as base64 data, an uploaded file ID, or a URL.

Variants
object

The file to be used as input, either as base64 data, an uploaded file ID, or a URL.

Properties
file_datastringoptional

The base64 encoded file data, used when passing the file to the model as a string.

file_idstringoptional

The ID of an uploaded file to use as input.

filenamestringoptional

The name of the file, used when passing the file to the model as a string.

file_urlstringoptional

The URL of the file, used when passing the file to the model as a URL.

JMESPathExpressionobject

A JMESPath expression which evaluates to a value.

Properties
$jmespathstring*required

A JMESPath expression.

StarlarkExpressionobject

A Starlark expression which evaluates to a value.

Properties
$starlarkstring*required

A Starlark expression.

JMESPathExpressionobject

A JMESPath expression which evaluates to a value.

Properties
$jmespathstring*required

A JMESPath expression.

StarlarkExpressionobject

A Starlark expression which evaluates to a value.

Properties
$starlarkstring*required

A Starlark expression.

JMESPathExpressionobject

A JMESPath expression which evaluates to a value.

Properties
$jmespathstring*required

A JMESPath expression.

StarlarkExpressionobject

A Starlark expression which evaluates to a value.

Properties
$starlarkstring*required

A Starlark expression.

nameunionoptional

An optional name for the participant. Provides the model information to differentiate between participants of the same role.

Variants
MessageNamestring

An optional name for the participant. Provides the model information to differentiate between participants of the same role.

JMESPathExpressionobject

A JMESPath expression which evaluates to a value.

Properties
$jmespathstring*required

A JMESPath expression.

StarlarkExpressionobject

A Starlark expression which evaluates to a value.

Properties
$starlarkstring*required

A Starlark expression.

ToolMessageExpressionobject

Messages sent by tools in response to tool calls made by the assistant.

Properties
role"tool"*required
contentunion*required

Rich content.

Variants
RichContentTextstring

Plain text content.

RichContentPartExpressionsarray

An array of rich content parts.

Items
TextRichContentPartExpressionobject

A text rich content part.

Properties
type"text"*required
textunion*required

The text content.

Variants
string

The text content.

JMESPathExpressionobject

A JMESPath expression which evaluates to a value.

Properties
$jmespathstring*required

A JMESPath expression.

StarlarkExpressionobject

A Starlark expression which evaluates to a value.

Properties
$starlarkstring*required

A Starlark expression.

ImageRichContentPartExpressionobject

An image rich content part.

Properties
type"image_url"*required
image_urlunion*required

The URL of the image and its optional detail level.

Variants
object

The URL of the image and its optional detail level.

Properties
urlstring*required

Either a URL of the image or the base64 encoded image data.

detailenumoptional

Specifies the detail level of the image.

Variants
"auto"
"low"
"high"
JMESPathExpressionobject

A JMESPath expression which evaluates to a value.

Properties
$jmespathstring*required

A JMESPath expression.

StarlarkExpressionobject

A Starlark expression which evaluates to a value.

Properties
$starlarkstring*required

A Starlark expression.

AudioRichContentPartExpressionobject

An audio rich content part.

Properties
type"input_audio"*required
input_audiounion*required

The audio data and its format.

Variants
object

The audio data and its format.

Properties
datastring*required

Base64 encoded audio data.

formatenum*required

The format of the encoded audio data.

Variants
"wav"
"mp3"
JMESPathExpressionobject

A JMESPath expression which evaluates to a value.

Properties
$jmespathstring*required

A JMESPath expression.

StarlarkExpressionobject

A Starlark expression which evaluates to a value.

Properties
$starlarkstring*required

A Starlark expression.

VideoRichContentPartExpressionobject

A video rich content part.

Properties
typeenum*required
Variants
"video_url"
"input_video"
video_urlunion*required

The video URL definition.

Variants
object
Properties
urlstring*required

URL of the video.

JMESPathExpressionobject

A JMESPath expression which evaluates to a value.

Properties
$jmespathstring*required

A JMESPath expression.

StarlarkExpressionobject

A Starlark expression which evaluates to a value.

Properties
$starlarkstring*required

A Starlark expression.

FileRichContentPartExpressionobject

A file rich content part.

Properties
type"file"*required
fileunion*required

The file to be used as input, either as base64 data, an uploaded file ID, or a URL.

Variants
object

The file to be used as input, either as base64 data, an uploaded file ID, or a URL.

Properties
file_datastringoptional

The base64 encoded file data, used when passing the file to the model as a string.

file_idstringoptional

The ID of an uploaded file to use as input.

filenamestringoptional

The name of the file, used when passing the file to the model as a string.

file_urlstringoptional

The URL of the file, used when passing the file to the model as a URL.

JMESPathExpressionobject

A JMESPath expression which evaluates to a value.

Properties
$jmespathstring*required

A JMESPath expression.

StarlarkExpressionobject

A Starlark expression which evaluates to a value.

Properties
$starlarkstring*required

A Starlark expression.

JMESPathExpressionobject

A JMESPath expression which evaluates to a value.

Properties
$jmespathstring*required

A JMESPath expression.

StarlarkExpressionobject

A Starlark expression which evaluates to a value.

Properties
$starlarkstring*required

A Starlark expression.

JMESPathExpressionobject

A JMESPath expression which evaluates to a value.

Properties
$jmespathstring*required

A JMESPath expression.

StarlarkExpressionobject

A Starlark expression which evaluates to a value.

Properties
$starlarkstring*required

A Starlark expression.

tool_call_idunion*required

The ID of the tool call that this message is responding to.

Variants
ToolMessageToolCallIdstring

The ID of the tool call that this message is responding to.

JMESPathExpressionobject

A JMESPath expression which evaluates to a value.

Properties
$jmespathstring*required

A JMESPath expression.

StarlarkExpressionobject

A Starlark expression which evaluates to a value.

Properties
$starlarkstring*required

A Starlark expression.

AssistantMessageExpressionobject

Messages sent by the model in response to user messages.

Properties
role"assistant"*required
contentunionoptional

Rich content.

Variants
RichContentTextstring

Plain text content.

RichContentPartExpressionsarray

An array of rich content parts.

Items
TextRichContentPartExpressionobject

A text rich content part.

Properties
type"text"*required
textunion*required

The text content.

Variants
string

The text content.

JMESPathExpressionobject

A JMESPath expression which evaluates to a value.

Properties
$jmespathstring*required

A JMESPath expression.

StarlarkExpressionobject

A Starlark expression which evaluates to a value.

Properties
$starlarkstring*required

A Starlark expression.

ImageRichContentPartExpressionobject

An image rich content part.

Properties
type"image_url"*required
image_urlunion*required

The URL of the image and its optional detail level.

Variants
object

The URL of the image and its optional detail level.

Properties
urlstring*required

Either a URL of the image or the base64 encoded image data.

detailenumoptional

Specifies the detail level of the image.

Variants
"auto"
"low"
"high"
JMESPathExpressionobject

A JMESPath expression which evaluates to a value.

Properties
$jmespathstring*required

A JMESPath expression.

StarlarkExpressionobject

A Starlark expression which evaluates to a value.

Properties
$starlarkstring*required

A Starlark expression.

AudioRichContentPartExpressionobject

An audio rich content part.

Properties
type"input_audio"*required
input_audiounion*required

The audio data and its format.

Variants
object

The audio data and its format.

Properties
datastring*required

Base64 encoded audio data.

formatenum*required

The format of the encoded audio data.

Variants
"wav"
"mp3"
JMESPathExpressionobject

A JMESPath expression which evaluates to a value.

Properties
$jmespathstring*required

A JMESPath expression.

StarlarkExpressionobject

A Starlark expression which evaluates to a value.

Properties
$starlarkstring*required

A Starlark expression.

VideoRichContentPartExpressionobject

A video rich content part.

Properties
typeenum*required
Variants
"video_url"
"input_video"
video_urlunion*required

The video URL definition.

Variants
object
Properties
urlstring*required

URL of the video.

JMESPathExpressionobject

A JMESPath expression which evaluates to a value.

Properties
$jmespathstring*required

A JMESPath expression.

StarlarkExpressionobject

A Starlark expression which evaluates to a value.

Properties
$starlarkstring*required

A Starlark expression.

FileRichContentPartExpressionobject

A file rich content part.

Properties
type"file"*required
fileunion*required

The file to be used as input, either as base64 data, an uploaded file ID, or a URL.

Variants
object

The file to be used as input, either as base64 data, an uploaded file ID, or a URL.

Properties
file_datastringoptional

The base64 encoded file data, used when passing the file to the model as a string.

file_idstringoptional

The ID of an uploaded file to use as input.

filenamestringoptional

The name of the file, used when passing the file to the model as a string.

file_urlstringoptional

The URL of the file, used when passing the file to the model as a URL.

JMESPathExpressionobject

A JMESPath expression which evaluates to a value.

Properties
$jmespathstring*required

A JMESPath expression.

StarlarkExpressionobject

A Starlark expression which evaluates to a value.

Properties
$starlarkstring*required

A Starlark expression.

JMESPathExpressionobject

A JMESPath expression which evaluates to a value.

Properties
$jmespathstring*required

A JMESPath expression.

StarlarkExpressionobject

A Starlark expression which evaluates to a value.

Properties
$starlarkstring*required

A Starlark expression.

JMESPathExpressionobject

A JMESPath expression which evaluates to a value.

Properties
$jmespathstring*required

A JMESPath expression.

StarlarkExpressionobject

A Starlark expression which evaluates to a value.

Properties
$starlarkstring*required

A Starlark expression.

nameunionoptional

An optional name for the participant. Provides the model information to differentiate between participants of the same role.

Variants
MessageNamestring

An optional name for the participant. Provides the model information to differentiate between participants of the same role.

JMESPathExpressionobject

A JMESPath expression which evaluates to a value.

Properties
$jmespathstring*required

A JMESPath expression.

StarlarkExpressionobject

A Starlark expression which evaluates to a value.

Properties
$starlarkstring*required

A Starlark expression.

refusalunionoptional

The refusal message by the assistant.

Variants
AssistantMessageRefusalstring

The refusal message by the assistant.

JMESPathExpressionobject

A JMESPath expression which evaluates to a value.

Properties
$jmespathstring*required

A JMESPath expression.

StarlarkExpressionobject

A Starlark expression which evaluates to a value.

Properties
$starlarkstring*required

A Starlark expression.

tool_callsunionoptional

Tool calls made by the assistant.

Variants
array

Tool calls made by the assistant.

Items
AssistantMessageToolCallFunctionExpressionobject

A function tool call made by the assistant.

Properties
type"function"*required
idunion*required

The unique identifier for the tool call.

Variants
AssistantMessageToolCallIdstring

The unique identifier for the tool call.

JMESPathExpressionobject

A JMESPath expression which evaluates to a value.

Properties
$jmespathstring*required

A JMESPath expression.

StarlarkExpressionobject

A Starlark expression which evaluates to a value.

Properties
$starlarkstring*required

A Starlark expression.

functionobject*required

The name and arguments of the function called.

Properties
nameunion*required

The name of the function called.

Variants
AssistantMessageToolCallFunctionNamestring

The name of the function called.

JMESPathExpressionobject

A JMESPath expression which evaluates to a value.

Properties
$jmespathstring*required

A JMESPath expression.

StarlarkExpressionobject

A Starlark expression which evaluates to a value.

Properties
$starlarkstring*required

A Starlark expression.

argumentsunion*required

The arguments passed to the function.

Variants
AssistantMessageToolCallFunctionArgumentsstring

The arguments passed to the function.

JMESPathExpressionobject

A JMESPath expression which evaluates to a value.

Properties
$jmespathstring*required

A JMESPath expression.

StarlarkExpressionobject

A Starlark expression which evaluates to a value.

Properties
$starlarkstring*required

A Starlark expression.

JMESPathExpressionobject

A JMESPath expression which evaluates to a value.

Properties
$jmespathstring*required

A JMESPath expression.

StarlarkExpressionobject

A Starlark expression which evaluates to a value.

Properties
$starlarkstring*required

A Starlark expression.

JMESPathExpressionobject

A JMESPath expression which evaluates to a value.

Properties
$jmespathstring*required

A JMESPath expression.

StarlarkExpressionobject

A Starlark expression which evaluates to a value.

Properties
$starlarkstring*required

A Starlark expression.

reasoningunionoptional

The reasoning provided by the assistant.

Variants
AssistantMessageReasoningstring

The reasoning provided by the assistant.

JMESPathExpressionobject

A JMESPath expression which evaluates to a value.

Properties
$jmespathstring*required

A JMESPath expression.

StarlarkExpressionobject

A Starlark expression which evaluates to a value.

Properties
$starlarkstring*required

A Starlark expression.

JMESPathExpressionobject

A JMESPath expression which evaluates to a value.

Properties
$jmespathstring*required

A JMESPath expression.

StarlarkExpressionobject

A Starlark expression which evaluates to a value.

Properties
$starlarkstring*required

A Starlark expression.

JMESPathExpressionobject

A JMESPath expression which evaluates to a value.

Properties
$jmespathstring*required

A JMESPath expression.

StarlarkExpressionobject

A Starlark expression which evaluates to a value.

Properties
$starlarkstring*required

A Starlark expression.

toolsunionoptional

A list of tools that the assistant can call. These are readonly and will only be useful for explaining prior tool calls or otherwise influencing behavior.

Variants
ToolExpressionsarray

A list of tools that the assistant can call.

Items
FunctionToolExpressionobject

A function tool that the assistant can call.

Properties
type"function"*required
functionobject*required

The definition of a function tool.

Properties
nameunion*required

The name of the function.

Variants
FunctionToolNamestring

The name of the function.

JMESPathExpressionobject

A JMESPath expression which evaluates to a value.

Properties
$jmespathstring*required

A JMESPath expression.

StarlarkExpressionobject

A Starlark expression which evaluates to a value.

Properties
$starlarkstring*required

A Starlark expression.

descriptionunionoptional

The description of the function.

Variants
FunctionToolDescriptionstring

The description of the function.

JMESPathExpressionobject

A JMESPath expression which evaluates to a value.

Properties
$jmespathstring*required

A JMESPath expression.

StarlarkExpressionobject

A Starlark expression which evaluates to a value.

Properties
$starlarkstring*required

A Starlark expression.

parametersunionoptional

The JSON schema defining the parameters of the function.

Variants
record
Values
JsonValueNullnull

Null

JsonValueBooleanboolean

Boolean

JsonValueNumbernumber

Number

JsonValueStringstring

String

JsonValueExpressionArrayarray

Array (values may be expressions)

Items
JsonValueExpression

A JSON value.

JsonValueExpressionObjectrecord

Object (values may be expressions)

Values
JsonValueExpression

A JSON value.

JMESPathExpressionobject

A JMESPath expression which evaluates to a value.

Properties
$jmespathstring*required

A JMESPath expression.

StarlarkExpressionobject

A Starlark expression which evaluates to a value.

Properties
$starlarkstring*required

A Starlark expression.

JMESPathExpressionobject

A JMESPath expression which evaluates to a value.

Properties
$jmespathstring*required

A JMESPath expression.

StarlarkExpressionobject

A Starlark expression which evaluates to a value.

Properties
$starlarkstring*required

A Starlark expression.

strictunionoptional

Whether to enforce strict adherence to the parameter schema.

Variants
FunctionToolStrictboolean

Whether to enforce strict adherence to the parameter schema.

JMESPathExpressionobject

A JMESPath expression which evaluates to a value.

Properties
$jmespathstring*required

A JMESPath expression.

StarlarkExpressionobject

A Starlark expression which evaluates to a value.

Properties
$starlarkstring*required

A Starlark expression.

JMESPathExpressionobject

A JMESPath expression which evaluates to a value.

Properties
$jmespathstring*required

A JMESPath expression.

StarlarkExpressionobject

A Starlark expression which evaluates to a value.

Properties
$starlarkstring*required

A Starlark expression.

JMESPathExpressionobject

A JMESPath expression which evaluates to a value.

Properties
$jmespathstring*required

A JMESPath expression.

StarlarkExpressionobject

A Starlark expression which evaluates to a value.

Properties
$starlarkstring*required

A Starlark expression.

responsesunion*required

A list of possible assistant responses which the LLMs in the Ensemble will vote on. The output scores will be of the same length, each corresponding to one response. The winner is the response with the highest score.

Variants
VectorResponseExpressionsarray

A list of possible assistant responses which the LLMs in the Ensemble will vote on. The output scores will be of the same length, each corresponding to one response. The winner is the response with the highest score.

Items
RichContentTextstring

Plain text content.

RichContentPartsarray

An array of rich content parts.

Items
TextRichContentPartobject

A text rich content part.

Properties
type"text"*required
textstring*required

The text content.

ImageRichContentPartobject

An image rich content part.

Properties
type"image_url"*required
image_urlobject*required

The URL of the image and its optional detail level.

Properties
urlstring*required

Either a URL of the image or the base64 encoded image data.

detailenumoptional

Specifies the detail level of the image.

Variants
"auto"
"low"
"high"
AudioRichContentPartobject

An audio rich content part.

Properties
type"input_audio"*required
input_audioobject*required

The audio data and its format.

Properties
datastring*required

Base64 encoded audio data.

formatenum*required

The format of the encoded audio data.

Variants
"wav"
"mp3"
VideoRichContentPartobject

A video rich content part.

Properties
typeenum*required
Variants
"video_url"
"input_video"
video_urlobject*required
Properties
urlstring*required

URL of the video.

FileRichContentPartobject

A file rich content part.

Properties
type"file"*required
fileobject*required

The file to be used as input, either as base64 data, an uploaded file ID, or a URL.

Properties
file_datastringoptional

The base64 encoded file data, used when passing the file to the model as a string.

file_idstringoptional

The ID of an uploaded file to use as input.

filenamestringoptional

The name of the file, used when passing the file to the model as a string.

file_urlstringoptional

The URL of the file, used when passing the file to the model as a URL.

JMESPathExpressionobject

A JMESPath expression which evaluates to a value.

Properties
$jmespathstring*required

A JMESPath expression.

StarlarkExpressionobject

A Starlark expression which evaluates to a value.

Properties
$starlarkstring*required

A Starlark expression.

JMESPathExpressionobject

A JMESPath expression which evaluates to a value.

Properties
$jmespathstring*required

A JMESPath expression.

StarlarkExpressionobject

A Starlark expression which evaluates to a value.

Properties
$starlarkstring*required

A Starlark expression.

outputunion*required

An expression which transforms the task result into a FunctionOutput. Receives `output` as one of 4 variants depending on task type: a single FunctionOutput (for non-mapped function tasks), an array of FunctionOutputs (for mapped function tasks), a VectorCompletionOutput (for non-mapped vector completion tasks), or an array of VectorCompletionOutputs (for mapped vector completion tasks). Must return a FunctionOutput valid for the parent function's type: scalar functions require a number in [0,1], vector functions require an array of numbers summing to ~1. The function's final output is the weighted average of all task outputs using profile weights. Receives: `input`, `output`.

Variants
JMESPathExpressionobject

A JMESPath expression which evaluates to a value.

Properties
$jmespathstring*required

A JMESPath expression.

StarlarkExpressionobject

A Starlark expression which evaluates to a value.

Properties
$starlarkstring*required

A Starlark expression.

PlaceholderScalarFunctionTaskExpressionobject

A placeholder scalar function task expression. Always outputs 0.5.

Properties
type"placeholder.scalar.function"*required
input_schemaunion*required

An input schema defining the structure of function inputs.

Variants
ObjectInputSchemaobject

An object input schema.

Properties
type"object"*required
descriptionstringoptional

The description of the object input.

propertiesrecord*required

The properties of the object input.

Values
InputSchema
requiredarrayoptional

The required properties of the object input.

Items
string
ArrayInputSchemaobject

An array input schema.

Properties
type"array"*required
descriptionstringoptional

The description of the array input.

minItemsnumbermin: 0max: 4294967295optional

The minimum number of items in the array input.

maxItemsnumbermin: 0max: 4294967295optional

The maximum number of items in the array input.

items*required
StringInputSchemaobject

A string input schema.

Properties
type"string"*required
descriptionstringoptional

The description of the string input.

enumarrayoptional

The enumeration of allowed string values.

Items
string
NumberInputSchemaobject

A number input schema.

Properties
type"number"*required
descriptionstringoptional

The description of the number input.

minimumnumberoptional

The minimum allowed value for the number input.

maximumnumberoptional

The maximum allowed value for the number input.

IntegerInputSchemaobject

An integer input schema.

Properties
type"integer"*required
descriptionstringoptional

The description of the integer input.

minimumnumbermin: 0max: 4294967295optional

The minimum allowed value for the integer input.

maximumnumbermin: 0max: 4294967295optional

The maximum allowed value for the integer input.

BooleanInputSchemaobject

A boolean input schema.

Properties
type"boolean"*required
descriptionstringoptional

The description of the boolean input.

ImageInputSchemaobject

An image input schema.

Properties
type"image"*required
descriptionstringoptional

The description of the image input.

AudioInputSchemaobject

An audio input schema.

Properties
type"audio"*required
descriptionstringoptional

The description of the audio input.

VideoInputSchemaobject

A video input schema.

Properties
type"video"*required
descriptionstringoptional

The description of the video input.

FileInputSchemaobject

A file input schema.

Properties
type"file"*required
descriptionstringoptional

The description of the file input.

AnyOfInputSchemaobject

A union of schemas - input must match at least one.

Properties
anyOfarray*required

The possible schemas that the input can match.

Items
InputSchema
skipunionoptional

An expression which evaluates to a boolean indicating whether to skip this task. Receives: `input`.

Variants
JMESPathExpressionobject

A JMESPath expression which evaluates to a value.

Properties
$jmespathstring*required

A JMESPath expression.

StarlarkExpressionobject

A Starlark expression which evaluates to a value.

Properties
$starlarkstring*required

A Starlark expression.

mapnumbermin: 0max: 4294967295optional

Index into the function's `input_maps` 2D array. When present, this task is compiled once per element in `input_maps[map]`, producing multiple task instances. Each compiled instance's expressions receive the current element as `map`.

inputunion*required

A value provided as input to a function.

Variants
ImageRichContentPartobject

An image rich content part.

Properties
type"image_url"*required
image_urlobject*required

The URL of the image and its optional detail level.

Properties
urlstring*required

Either a URL of the image or the base64 encoded image data.

detailenumoptional

Specifies the detail level of the image.

Variants
"auto"
"low"
"high"
AudioRichContentPartobject

An audio rich content part.

Properties
type"input_audio"*required
input_audioobject*required

The audio data and its format.

Properties
datastring*required

Base64 encoded audio data.

formatenum*required

The format of the encoded audio data.

Variants
"wav"
"mp3"
VideoRichContentPartobject

A video rich content part.

Properties
typeenum*required
Variants
"video_url"
"input_video"
video_urlobject*required
Properties
urlstring*required

URL of the video.

FileRichContentPartobject

A file rich content part.

Properties
type"file"*required
fileobject*required

The file to be used as input, either as base64 data, an uploaded file ID, or a URL.

Properties
file_datastringoptional

The base64 encoded file data, used when passing the file to the model as a string.

file_idstringoptional

The ID of an uploaded file to use as input.

filenamestringoptional

The name of the file, used when passing the file to the model as a string.

file_urlstringoptional

The URL of the file, used when passing the file to the model as a URL.

record
Values
InputValueExpression
array
Items
InputValueExpression
string
number
boolean
JMESPathExpressionobject

A JMESPath expression which evaluates to a value.

Properties
$jmespathstring*required

A JMESPath expression.

StarlarkExpressionobject

A Starlark expression which evaluates to a value.

Properties
$starlarkstring*required

A Starlark expression.

outputunion*required

An expression which transforms the task result into a FunctionOutput. Receives `output` as one of 4 variants depending on task type: a single FunctionOutput (for non-mapped function tasks), an array of FunctionOutputs (for mapped function tasks), a VectorCompletionOutput (for non-mapped vector completion tasks), or an array of VectorCompletionOutputs (for mapped vector completion tasks). Must return a FunctionOutput valid for the parent function's type: scalar functions require a number in [0,1], vector functions require an array of numbers summing to ~1. The function's final output is the weighted average of all task outputs using profile weights. Receives: `input`, `output`.

Variants
JMESPathExpressionobject

A JMESPath expression which evaluates to a value.

Properties
$jmespathstring*required

A JMESPath expression.

StarlarkExpressionobject

A Starlark expression which evaluates to a value.

Properties
$starlarkstring*required

A Starlark expression.

PlaceholderVectorFunctionTaskExpressionobject

A placeholder vector function task expression. Always outputs an equalized vector.

Properties
type"placeholder.vector.function"*required
input_schemaunion*required

An input schema defining the structure of function inputs.

Variants
ObjectInputSchemaobject

An object input schema.

Properties
type"object"*required
descriptionstringoptional

The description of the object input.

propertiesrecord*required

The properties of the object input.

Values
InputSchema
requiredarrayoptional

The required properties of the object input.

Items
string
ArrayInputSchemaobject

An array input schema.

Properties
type"array"*required
descriptionstringoptional

The description of the array input.

minItemsnumbermin: 0max: 4294967295optional

The minimum number of items in the array input.

maxItemsnumbermin: 0max: 4294967295optional

The maximum number of items in the array input.

items*required
StringInputSchemaobject

A string input schema.

Properties
type"string"*required
descriptionstringoptional

The description of the string input.

enumarrayoptional

The enumeration of allowed string values.

Items
string
NumberInputSchemaobject

A number input schema.

Properties
type"number"*required
descriptionstringoptional

The description of the number input.

minimumnumberoptional

The minimum allowed value for the number input.

maximumnumberoptional

The maximum allowed value for the number input.

IntegerInputSchemaobject

An integer input schema.

Properties
type"integer"*required
descriptionstringoptional

The description of the integer input.

minimumnumbermin: 0max: 4294967295optional

The minimum allowed value for the integer input.

maximumnumbermin: 0max: 4294967295optional

The maximum allowed value for the integer input.

BooleanInputSchemaobject

A boolean input schema.

Properties
type"boolean"*required
descriptionstringoptional

The description of the boolean input.

ImageInputSchemaobject

An image input schema.

Properties
type"image"*required
descriptionstringoptional

The description of the image input.

AudioInputSchemaobject

An audio input schema.

Properties
type"audio"*required
descriptionstringoptional

The description of the audio input.

VideoInputSchemaobject

A video input schema.

Properties
type"video"*required
descriptionstringoptional

The description of the video input.

FileInputSchemaobject

A file input schema.

Properties
type"file"*required
descriptionstringoptional

The description of the file input.

AnyOfInputSchemaobject

A union of schemas - input must match at least one.

Properties
anyOfarray*required

The possible schemas that the input can match.

Items
InputSchema
output_lengthunion*required

The length of the output vector.

Variants
numbermin: 0max: 4294967295

The fixed length of the output vector.

JMESPathExpressionobject

A JMESPath expression which evaluates to a value.

Properties
$jmespathstring*required

A JMESPath expression.

StarlarkExpressionobject

A Starlark expression which evaluates to a value.

Properties
$starlarkstring*required

A Starlark expression.

input_splitunion*required

Splits the function input into an array of sub-inputs, one per output element. Receives: `input`.

Variants
JMESPathExpressionobject

A JMESPath expression which evaluates to a value.

Properties
$jmespathstring*required

A JMESPath expression.

StarlarkExpressionobject

A Starlark expression which evaluates to a value.

Properties
$starlarkstring*required

A Starlark expression.

input_mergeunion*required

Recombines a variable-size, arbitrarily-ordered subset of sub-inputs back into one input. Receives: `input` (an array of sub-inputs).

Variants
JMESPathExpressionobject

A JMESPath expression which evaluates to a value.

Properties
$jmespathstring*required

A JMESPath expression.

StarlarkExpressionobject

A Starlark expression which evaluates to a value.

Properties
$starlarkstring*required

A Starlark expression.

skipunionoptional

An expression which evaluates to a boolean indicating whether to skip this task. Receives: `input`.

Variants
JMESPathExpressionobject

A JMESPath expression which evaluates to a value.

Properties
$jmespathstring*required

A JMESPath expression.

StarlarkExpressionobject

A Starlark expression which evaluates to a value.

Properties
$starlarkstring*required

A Starlark expression.

mapnumbermin: 0max: 4294967295optional

Index into the function's `input_maps` 2D array. When present, this task is compiled once per element in `input_maps[map]`, producing multiple task instances. Each compiled instance's expressions receive the current element as `map`.

inputunion*required

A value provided as input to a function.

Variants
ImageRichContentPartobject

An image rich content part.

Properties
type"image_url"*required
image_urlobject*required

The URL of the image and its optional detail level.

Properties
urlstring*required

Either a URL of the image or the base64 encoded image data.

detailenumoptional

Specifies the detail level of the image.

Variants
"auto"
"low"
"high"
AudioRichContentPartobject

An audio rich content part.

Properties
type"input_audio"*required
input_audioobject*required

[...]
